"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var ElasticsearchModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const elasticsearch_client_provider_1 = require("./elasticsearch-client.provider");
const elasticsearch_constant_1 = require("./elasticsearch.constant");
const elasticsearch_helper_1 = require("./elasticsearch.helper");
let ElasticsearchModule = ElasticsearchModule_1 = class ElasticsearchModule {
    constructor(options) {
        this.options = options;
    }
    static register(options) {
        return {
            module: ElasticsearchModule_1,
            providers: [
                elasticsearch_client_provider_1.createElasticsearchClient(options.name),
                { provide: elasticsearch_constant_1.ELASTICSEARCH_MODULE_OPTIONS, useValue: options },
            ],
            exports: [elasticsearch_helper_1.getClientToken(options.name)],
        };
    }
    static registerAsync(options) {
        return {
            module: ElasticsearchModule_1,
            imports: options.imports || [],
            providers: [
                elasticsearch_client_provider_1.createElasticsearchClient(options.name),
                ...this.createAsyncProviders(options),
            ],
            exports: [elasticsearch_helper_1.getClientToken(options.name)],
        };
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        return [
            this.createAsyncOptionsProvider(options),
            { provide: options.useClass, useClass: options.useClass },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: elasticsearch_constant_1.ELASTICSEARCH_MODULE_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: elasticsearch_constant_1.ELASTICSEARCH_MODULE_OPTIONS,
            useFactory: (optionsFactory) => __awaiter(this, void 0, void 0, function* () { return yield optionsFactory.createElasticsearchOptions(options.name); }),
            inject: [options.useExisting || options.useClass],
        };
    }
};
ElasticsearchModule = ElasticsearchModule_1 = __decorate([
    common_1.Module({}),
    __param(0, common_1.Inject(elasticsearch_constant_1.ELASTICSEARCH_MODULE_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], ElasticsearchModule);
exports.ElasticsearchModule = ElasticsearchModule;
