import { Client } from '@elastic/elasticsearch';
import { ElasticsearchIndexConfig, BulkIndexId } from './interfaces';
export declare class ElasticsearchService<T> {
    readonly client: Client;
    readonly config: ElasticsearchIndexConfig<T>;
    constructor(client: Client, config: ElasticsearchIndexConfig<T>);
    hasIndex(): Promise<boolean>;
    getIndexStats(): Promise<any>;
    createIndex(): Promise<any>;
    updateIndex(): Promise<any>;
    deleteIndex(): Promise<any>;
    indexDocument(id: number, document: Partial<T>): Promise<any>;
    bulkIndexDocuments(documents: Array<BulkIndexId | Partial<T>>): Promise<any>;
    deleteDocument(id: number): Promise<any>;
}
